diff -uwr sourceold/scripts/tcw_vehicle.cpp source/scripts/tcw_vehicle.cpp
--- sourceold/scripts/tcw_vehicle.cpp	2012-02-02 09:44:43.121093700 +0800
+++ source/scripts/tcw_vehicle.cpp	2012-06-09 08:11:12.133789000 +0800
@@ -1,5 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://www.tiberiumcrystalwar.com
+	Scripts from - http://www.tiberiumcrystalwar.com
 	Copyright 2011-2012 MPF
 
 	This file is part of the Renegade scripts.dll
@@ -446,8 +446,8 @@
 {
 	if (message == CUSTOM_EVENT_VEHICLE_ENTERED)
 	{
-		if ( (strcmp(Commands->Get_Preset_Name(sender),"TCW_GDI_Commando") == 0) || (strcmp(Commands->Get_Preset_Name(sender),"TCW_GDI_Commando_Low") == 0) || 
-			 (strcmp(Commands->Get_Preset_Name(sender),"TCW_Nod_Commando") == 0) || (strcmp(Commands->Get_Preset_Name(sender),"TCW_Nod_Commando_Low") == 0) )
+		if ( (strcmp(Commands->Get_Preset_Name(Get_Vehicle_Driver(obj)),"TCW_GDI_Commando") == 0) || (strcmp(Commands->Get_Preset_Name(Get_Vehicle_Driver(obj)),"TCW_GDI_Commando_Low") == 0) || 
+			 (strcmp(Commands->Get_Preset_Name(Get_Vehicle_Driver(obj)),"TCW_Nod_Commando") == 0) || (strcmp(Commands->Get_Preset_Name(Get_Vehicle_Driver(obj)),"TCW_Nod_Commando_Low") == 0) )
 		{
 			Commands->Start_Timer(obj,this,0.5f,100100);
 		}
@@ -458,6 +458,11 @@
 		}
 		else if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_APC") == 0) || (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_APC") == 0) )
 		{
+			if (Get_Vehicle_Occupant_Count(obj) == 2)
+			{
+				Create_2D_WAV_Sound_Player(Get_Vehicle_Driver(obj),"apc_full.wav");
+				Create_2D_WAV_Sound_Player(Get_Vehicle_Occupant(obj,1),"apc_full.wav");
+			}
 			if (Get_Vehicle_Occupant(obj,1))//if there is a passenger
 			{
 				if ( (strcmp(Commands->Get_Preset_Name(Get_Vehicle_Occupant(obj,1)),"TCW_GDI_Missile_Squad") == 0) || (strcmp(Commands->Get_Preset_Name(Get_Vehicle_Occupant(obj,1)),"TCW_Nod_RocketGuy") == 0) || (strcmp(Commands->Get_Preset_Name(Get_Vehicle_Occupant(obj,1)),"TCW_Nod_RocketGuy_Low") == 0) || (strcmp(Commands->Get_Preset_Name(Get_Vehicle_Occupant(obj,1)),"TCW_GDI_Missile_Squad_Low") == 0) )
@@ -477,6 +482,17 @@
 				}
 			}
 		}
+		else if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Chinook") == 0) || (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Chinook") == 0) )
+		{
+			if (Get_Vehicle_Occupant_Count(obj) == 5)
+			{
+				Create_2D_WAV_Sound_Player(Get_Vehicle_Driver(obj),"apc_full.wav");
+				Create_2D_WAV_Sound_Player(Get_Vehicle_Occupant(obj,1),"apc_full.wav");
+				Create_2D_WAV_Sound_Player(Get_Vehicle_Occupant(obj,2),"apc_full.wav");
+				Create_2D_WAV_Sound_Player(Get_Vehicle_Occupant(obj,3),"apc_full.wav");
+				Create_2D_WAV_Sound_Player(Get_Vehicle_Occupant(obj,4),"apc_full.wav");
+			}
+		}
 	}
 	else if (message == CUSTOM_EVENT_VEHICLE_EXITED)
 	{
@@ -504,6 +520,32 @@
 	{ 
 		if (param == 1)
 		{
+			if (strcmp(Commands->Get_Preset_Name(sender),"TCW_GDI_Command_Post") == 0)
+			{
+				if (!revealed)
+				{
+					Commands->Enable_Stealth(obj, false);
+					Commands->Start_Timer(obj,this,2.0f,1005);//enable stealh again
+					if (playdetected)
+					{
+						if (Commands->Get_Player_Type(obj) == 0)
+						{
+							Create_2D_WAV_Sound_Team("stealth_unit_detected_gdi.wav",1);
+							Send_Message_Team(1,255,204,0,"Stealth unit detected.");
+						}
+						else if (Commands->Get_Player_Type(obj) == 1)
+						{
+							Create_2D_WAV_Sound_Team("stealth_unit_detected_nod.wav",0);
+							Send_Message_Team(0,255,0,0,"Stealth unit detected.");
+						}
+						playdetected = false;
+						Commands->Start_Timer(obj,this,10.0f,1006);//playdetected true
+					}	
+					revealed = true;
+				}
+			}
+			else
+			{
 			if (Commands->Get_Player_Type(obj) != Commands->Get_Player_Type(sender))
 			{
 				Vector3 mypos = Commands->Get_Position(obj);
@@ -535,6 +577,7 @@
 					}
 				}
 			}
+			}
 		}
 	}
 }
diff -uwr sourceold/scripts/tcw_vehicle.h source/scripts/tcw_vehicle.h
--- sourceold/scripts/tcw_vehicle.h	2012-02-02 09:44:43.187500000 +0800
+++ source/scripts/tcw_vehicle.h	2012-06-09 08:11:12.201171800 +0800
@@ -1,5 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://www.tiberiumcrystalwar.com
+	Scripts from - http://www.tiberiumcrystalwar.com
 	Copyright 2011-2012 MPF
 
 	This file is part of the Renegade scripts.dll
diff -uwr sourceold/scripts/tcw_zone.cpp source/scripts/tcw_zone.cpp
--- sourceold/scripts/tcw_zone.cpp	2012-02-02 09:44:43.118164000 +0800
+++ source/scripts/tcw_zone.cpp	2012-06-09 08:11:12.308593700 +0800
@@ -1,5 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://www.tiberiumcrystalwar.com
+	Scripts from - http://www.tiberiumcrystalwar.com
 	Copyright 2011-2012 MPF
 
 	This file is part of the Renegade scripts.dll
@@ -29,7 +29,7 @@
 			if (Is_VTOL(enter))
 			{
 				GameObject *vobj = 0;
-				if (Is_Vehicle(enter))
+				if (enter && enter->As_VehicleGameObj())
 				{
 					vobj = Get_Vehicle(enter);
 				}
diff -uwr sourceold/scripts/tcw_zone.h source/scripts/tcw_zone.h
--- sourceold/scripts/tcw_zone.h	2012-02-02 09:44:43.158203100 +0800
+++ source/scripts/tcw_zone.h	2012-06-09 08:11:12.164062500 +0800
@@ -1,5 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://www.tiberiumcrystalwar.com
+	Scripts from - http://www.tiberiumcrystalwar.com
 	Copyright 2011-2012 MPF
 
 	This file is part of the Renegade scripts.dll
diff -uwr sourceold/scripts/weaponmgr.h source/scripts/weaponmgr.h
--- sourceold/scripts/weaponmgr.h	2011-10-11 21:40:30.001953100 +0800
+++ source/scripts/weaponmgr.h	2012-05-06 16:37:05.435460900 +0800
@@ -29,6 +29,9 @@
 	virtual bool								Save( ChunkSaveClass &csave );
 	virtual bool								Load( ChunkLoadClass &cload );
 	virtual const PersistFactoryClass &	Get_Factory( void ) const;
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE( AmmoDefinitionClass, DefinitionClass );
 	bool operator == ( const AmmoDefinitionClass & vector) const { return false; }
 	bool operator != ( const AmmoDefinitionClass & vector) const	{ return true; }
@@ -101,6 +104,10 @@
 	virtual bool								Save( ChunkSaveClass &csave );
 	virtual bool								Load( ChunkLoadClass &cload );
 	virtual const PersistFactoryClass &	Get_Factory( void ) const;
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+	virtual void                        DumpPhys (FileClass &file);
+#endif
 	DECLARE_EDITABLE( WeaponDefinitionClass, DefinitionClass );
 	bool operator == ( const WeaponDefinitionClass & vector) const  { return false; }
 	bool operator != ( const WeaponDefinitionClass & vector) const  { return true; }
@@ -149,8 +156,12 @@
 
 class ExplosionDefinitionClass : public DefinitionClass {
 public:
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+	virtual void                        DumpPhys (FileClass &file);
+#endif
 	DECLARE_EDITABLE(ExplosionDefinitionClass,DefinitionClass);
-	uint32 PhysDefID;
+	int PhysDefID;
 	uint32 SoundDefID;
 	float DamageRadius;
 	float DamageStrength;
diff -uwr sourceold/scripts/wwmath.cpp source/scripts/wwmath.cpp
--- sourceold/scripts/wwmath.cpp	2011-10-11 23:13:07.331054600 +0800
+++ source/scripts/wwmath.cpp	2012-04-14 04:09:46.957031200 +0800
@@ -12,10 +12,10 @@
 #include "General.h"
 #include "wwmath.h"
 #include <stdlib.h>
-SCRIPTS_API REF_ARR_DEF2(_FastAcosTable,float,ARC_TABLE_SIZE,0x00852FB0,0x00852198);
-SCRIPTS_API REF_ARR_DEF2(_FastAsinTable,float,ARC_TABLE_SIZE,0x00850FB0,0x00850198);
-SCRIPTS_API REF_ARR_DEF2(_FastSinTable,float,SIN_TABLE_SIZE,0x0084FFB0,0x0084F198);
-SCRIPTS_API REF_ARR_DEF2(_FastInvSinTable,float,SIN_TABLE_SIZE,0x00851FB0,0x00851198);
+SCRIPTS_API REF_ARR_DEF3(_FastAcosTable,float,ARC_TABLE_SIZE,0x00852FB0,0x00852198,0x0087145C);
+SCRIPTS_API REF_ARR_DEF3(_FastAsinTable,float,ARC_TABLE_SIZE,0x00850FB0,0x00850198,0x0086F45C);
+SCRIPTS_API REF_ARR_DEF3(_FastSinTable,float,SIN_TABLE_SIZE,0x0084FFB0,0x0084F198,0x0086E45C);
+SCRIPTS_API REF_ARR_DEF3(_FastInvSinTable,float,SIN_TABLE_SIZE,0x00851FB0,0x00851198,0x0087045C);
 void WWMath::Init(void)
 {
 	for (int a=0;a<ARC_TABLE_SIZE;++a) {
diff -uwr sourceold/scripts/wwmath.h source/scripts/wwmath.h
--- sourceold/scripts/wwmath.h	2011-11-22 14:49:49.161132800 +0800
+++ source/scripts/wwmath.h	2012-04-14 04:09:46.381835900 +0800
@@ -37,13 +37,11 @@
 #endif
 const int ARC_TABLE_SIZE=1024;
 const int SIN_TABLE_SIZE=1024;
-#ifndef TTLE_EXPORTS
 #ifndef EXTERNAL
-SCRIPTS_API extern REF_ARR_DECL2(_FastAcosTable,float,ARC_TABLE_SIZE);
-SCRIPTS_API extern REF_ARR_DECL2(_FastAsinTable,float,ARC_TABLE_SIZE);
-SCRIPTS_API extern REF_ARR_DECL2(_FastSinTable,float,SIN_TABLE_SIZE);
-SCRIPTS_API extern REF_ARR_DECL2(_FastInvSinTable,float,SIN_TABLE_SIZE);
-#endif
+SCRIPTS_API extern REF_ARR_DECL3(_FastAcosTable,float,ARC_TABLE_SIZE);
+SCRIPTS_API extern REF_ARR_DECL3(_FastAsinTable,float,ARC_TABLE_SIZE);
+SCRIPTS_API extern REF_ARR_DECL3(_FastSinTable,float,SIN_TABLE_SIZE);
+SCRIPTS_API extern REF_ARR_DECL3(_FastInvSinTable,float,SIN_TABLE_SIZE);
 #endif
 class SCRIPTS_API WWMath
 {
@@ -63,14 +61,12 @@
 	static TT_INLINE float Sqrt(float val);
 	static float __fastcall Inv_Sqrt(float a);
 	static TT_INLINE long	 Float_To_Long(float f);
-#ifndef TTLE_EXPORTS
 	static TT_INLINE float Fast_Sin(float val);
 	static TT_INLINE float Fast_Inv_Sin(float val);
 	static TT_INLINE float Fast_Cos(float val);
 	static TT_INLINE float Fast_Inv_Cos(float val);
 	static TT_INLINE float Fast_Acos(float val);
 	static TT_INLINE float Fast_Asin(float val);
-#endif
 	static TT_INLINE float Acos(float val);
 	static TT_INLINE float Asin(float val);
 	static float Atan(float x) { return static_cast<float>(atan(x)); }
@@ -252,7 +248,6 @@
 	return retval;
 }
 
-#ifndef TTLE_EXPORTS
 #ifndef EXTERNAL
 TT_INLINE float WWMath::Fast_Sin(float val)
 {
@@ -303,13 +298,11 @@
 	return (1.0f - frac) * _FastAcosTable[idx0] + frac * _FastAcosTable[idx1];
 }
 #endif
-#endif
 TT_INLINE float WWMath::Acos(float val)
 {
 	return (float)acos(val);
 }
 
-#ifndef TTLE_EXPORTS
 #ifndef EXTERNAL
 TT_INLINE float WWMath::Fast_Asin(float val)
 {
@@ -327,7 +320,6 @@
 	return (1.0f - frac) * _FastAsinTable[idx0] + frac * _FastAsinTable[idx1];
 }
 #endif
-#endif
 TT_INLINE float WWMath::Asin(float val)
 {
 	return (float)asin(val);
diff -uwr sourceold/scripts/z.cpp source/scripts/z.cpp
--- sourceold/scripts/z.cpp	2011-10-11 23:14:30.261718700 +0800
+++ source/scripts/z.cpp	2012-04-24 21:25:31.657226500 +0800
@@ -15,6 +15,10 @@
 #include "z.h"
 #include "BuildingGameObjDef.h"
 #include "VehicleGameObjDef.h"
+#include "ScriptableGameObj.h"
+#ifdef SSGM
+#include "gmgame.h"
+#endif
 
 
 void z_I_May_Not_Place_Defenses::Created(GameObject *obj)
@@ -422,7 +426,7 @@
 
 void z_Teleport_Powerup::Custom(GameObject *obj,int message,int param,GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Vector3 spawn_position;
 		spawn_position = Get_Vector3_Parameter("Location");
@@ -458,7 +462,7 @@
 
 void z_ChangeTeamPowerup::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		char pick[256];
 		char cht[200];
@@ -1071,7 +1075,7 @@
 void z_Pup_Allied_Tanya::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
 	int RandomNum = Commands->Get_Random_Int(1,3);
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		char snd[100];
 		Change_Character(sender,"Allied_Tanya");
@@ -1093,7 +1097,7 @@
 
 void z_Pup_Allied_RocketGuy::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"Allied_Rocket_Soldier");
 	}
@@ -1101,7 +1105,7 @@
 
 void z_Pup_Allied_Medic::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"Allied_Medic");
 	}
@@ -1109,7 +1113,7 @@
 
 void z_Pup_Allied_Medic_Coop::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"Allied_Medic_Coop");
 	}
@@ -1117,21 +1121,21 @@
 
 void z_Pup_Allied_Sniper::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"Allied_Sniper");
 	}
 }
 void z_Pup_Allied_Spy::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"Allied_Spy_Coop");
 	}
 }
 void z_Pup_Allied_Officer::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"Allied_Captain");
 	}
@@ -1139,7 +1143,7 @@
 
 void z_Pup_Allied_Mechanic::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"Allied_Mechanic");
 	}
@@ -1147,7 +1151,7 @@
 
 void z_Pup_Allied_Sniper_Coop::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"Allied_Sniper_Coop");
 	}
@@ -1908,7 +1912,7 @@
 
 void z_Pickup_Send_Custom::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("ID")),Get_Int_Parameter("Message"),Get_Int_Parameter("Param"),Get_Float_Parameter("Delay"));
 	}
@@ -1991,12 +1995,16 @@
 	Vector3 pos2;
 	float distance;
 	GameObject *object = Commands->Find_Object(number);
+	if (!object)
+	{
+		return;
+	}
 	pos1 = Commands->Get_Position(obj);
 	pos2 = Commands->Get_Position(object);
 	distance = Commands->Get_Distance(pos1,pos2);
 	if (distance <= 10.0)
 	{
-		if (Is_Vehicle(object))
+		if (object->As_VehicleGameObj())
 		{
 			if (Get_Vehicle_Mode(object) == VEHICLE_TYPE_FLYING)
 			{
@@ -2025,12 +2033,16 @@
 	Vector3 pos2;
 	float distance;
 	GameObject *object = Commands->Find_Object(number);
+	if (!object)
+	{
+		return;
+	}
 	pos1 = Commands->Get_Position(obj);
 	pos2 = Commands->Get_Position(object);
 	distance = Commands->Get_Distance(pos1,pos2);
 	if (distance <= 10.0)
 	{
-		if (Is_Vehicle(object))
+		if (object->As_VehicleGameObj())
 		{
 			if (Get_Vehicle_Mode(object) == VEHICLE_TYPE_FLYING)
 			{
@@ -2404,13 +2416,13 @@
 						else
 						{
 							//new is a player(in tank),old is not
-							if (Is_Soldier(old))
+							if (old->As_SoldierGameObj())
 							{
 								//old is a soldier
 								//switch to new target,old not worth it
 								selected = target;
 							}
-							else if (Is_Vehicle(old))
+							else if (old->As_VehicleGameObj())
 							{
 								//old is a vehicle,new is a player in tank
 								//switch based on distance
@@ -2445,13 +2457,13 @@
 						else
 						{
 							//new is a player on foot,old is not a player
-							if (Is_Soldier(old))
+							if (old->As_SoldierGameObj())
 							{
 								//old is a soldier
 								//switch to new target,old not worth it
 								selected = target;
 							}
-							else if (Is_Vehicle(old))
+							else if (old->As_VehicleGameObj())
 							{
 								//old is a vehicle
 								//switch if old out of range and new is close
@@ -2473,13 +2485,13 @@
 					if (vehicle) //is the old in a vehicle?
 					{
 						//old in vehicle
-						if (Is_Soldier(target))
+						if (target->As_SoldierGameObj())
 						{
 							//new is a soldier,old is player in a tank
 							//Perhaps an out of range check here?
 							selected = 0; //keep old					
 						}
-						else if (Is_Vehicle(target))
+						else if (target->As_VehicleGameObj())
 						{
 							//new is a vehicle,old is player in a tank
 							//switch if new closer
@@ -2488,12 +2500,12 @@
 					}
 					else //old on foot
 					{
-						if (Is_Soldier(target))
+						if (target->As_SoldierGameObj())
 						{
 							//new is a soldier
 							selected = Get_Closest(obj,target,old);
 						}
-						else if (Is_Vehicle(target))
+						else if (target->As_VehicleGameObj())
 						{
 							//new is a vehicle,old just a player
 							selected = target;
@@ -2591,7 +2603,7 @@
 
 	if (target)//Just to be on the safe side
 	{
-		if (Is_Soldier(target)) //is the target a soldier?
+		if (target->As_SoldierGameObj()) //is the target a soldier?
 		{
 			if (Get_Int_Parameter("vsSoldier")) 
 				return true; //Use Primary
@@ -2599,7 +2611,7 @@
 				return false; //Use Secondary
 		}
 
-		if (Is_Vehicle(target))
+		if (target->As_VehicleGameObj())
 		{
 			if (Get_Vehicle_Mode(target) != VEHICLE_TYPE_FLYING)
 			{
@@ -2657,12 +2669,16 @@
 	Vector3 pos2;
 	float distance;
 	GameObject *object = Commands->Find_Object(number);
+	if (!object)
+	{
+		return;
+	}
 	pos1 = Commands->Get_Position(obj);
 	pos2 = Commands->Get_Position(object);
 	distance = Commands->Get_Distance(pos1,pos2);
 	if (distance <= 10.0)
 	{
-		if (Is_Vehicle(object))
+		if (object->As_VehicleGameObj())
 		{
 			if (Get_Vehicle_Mode(object) == VEHICLE_TYPE_FLYING)
 			{
@@ -2781,7 +2797,7 @@
 {
 	/* This code was moved to the ssgm.ini under [General] as "PlayPowerupSounds"
 
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		if (strstr(Commands->Get_Preset_Name(obj),"CnC_POW_MineRemote_02"))
 		{
@@ -3584,7 +3600,7 @@
 	{
 		return;
 	}
-	if ((Is_Vehicle(enterer)) && (Is_VTOL(enterer)))
+	if ((enterer->As_VehicleGameObj()) && (Is_VTOL(enterer)))
 	{
 		Commands->Start_Timer(obj,this,1.0,Commands->Get_ID(enterer));
 	}
diff -uwr sourceold/scripts/z_buildingrevive.cpp source/scripts/z_buildingrevive.cpp
--- sourceold/scripts/z_buildingrevive.cpp	2011-10-11 23:14:19.441406200 +0800
+++ source/scripts/z_buildingrevive.cpp	2012-04-28 02:04:08.709960900 +0800
@@ -58,11 +58,13 @@
 {
 	if (allowpoke)
 	{
-		if (Find_Building(1,BuildingConstants::TYPE_CONYARD))
+		if (Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD))
 		{
-			if (!Is_Building_Dead(Find_Building(1,BuildingConstants::TYPE_CONYARD)))
+			if (!Is_Building_Dead(Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD)))
 			{
-				if (!Is_Building_Dead(Find_Building(1,BuildingConstants::TYPE_SOLDIER_FACTORY)))
+				if (Find_Building_By_Type(1,BuildingConstants::TYPE_SOLDIER_FACTORY))
+				{
+					if (!Is_Building_Dead(Find_Building_By_Type(1,BuildingConstants::TYPE_SOLDIER_FACTORY)))
 				{
 					//lolalive
 				}
@@ -79,7 +81,7 @@
 						currentamount = currentamount + pokecost;
 						if (currentamount == buildingcost)
 						{
-							GameObject *abar = Find_Building(1,BuildingConstants::TYPE_SOLDIER_FACTORY);
+								GameObject *abar = Find_Building_By_Type(1,BuildingConstants::TYPE_SOLDIER_FACTORY);
 							Restore_Building(abar);
 							Commands->Set_Health(abar,Commands->Get_Max_Health(obj));
 							Commands->Create_2D_WAV_Sound("eva_newconst.wav");
@@ -88,6 +90,7 @@
 					}
 				}
 			}
+			}
 			else
 			{
 				Send_Message_Player(poker,255,255,255,"Access Denied. Your Construction Yard is dead.");
@@ -122,59 +125,86 @@
 	int team = Get_Int_Parameter("Team");
 	if (type == 1)
 	{
-		GameObject *bing = Find_Building(team,BuildingConstants::TYPE_BASE_DEFENSE);
+		GameObject *bing = Find_Building_By_Type(team,BuildingConstants::TYPE_BASE_DEFENSE);
+		if (bing)
+		{
 		Restore_Building(bing);
 		Commands->Set_Health(bing,Commands->Get_Max_Health(obj));
 	}
+	}
 	else if (type == 2)
 	{
-		GameObject *bing = Find_Building(team,BuildingConstants::TYPE_COM_CENTER);
+		GameObject *bing = Find_Building_By_Type(team,BuildingConstants::TYPE_COM_CENTER);
+		if (bing)
+		{
 		Restore_Building(bing);
 		Commands->Set_Health(bing,Commands->Get_Max_Health(obj));
 	}
+	}
 	else if (type == 3)
 	{
-		GameObject *bing = Find_Building(team,BuildingConstants::TYPE_CONYARD);
+		GameObject *bing = Find_Building_By_Type(team,BuildingConstants::TYPE_CONYARD);
+		if (bing)
+		{
 		Restore_Building(bing);
 		Commands->Set_Health(bing,Commands->Get_Max_Health(obj));
 	}
+	}
 	else if (type == 4)
 	{
-		GameObject *bing = Find_Building(team,BuildingConstants::TYPE_HELIPAD);
+		GameObject *bing = Find_Building_By_Type(team,BuildingConstants::TYPE_HELIPAD);
+		if (bing)
+		{
 		Restore_Building(bing);
 		Commands->Set_Health(bing,Commands->Get_Max_Health(obj));
 	}
+	}
 	else if (type == 5)
 	{
-		GameObject *bing = Find_Building(team,BuildingConstants::TYPE_POWER_PLANT);
+		GameObject *bing = Find_Building_By_Type(team,BuildingConstants::TYPE_POWER_PLANT);
+		if (bing)
+		{
 		Restore_Building(bing);
 		Commands->Set_Health(bing,Commands->Get_Max_Health(obj));
 	}
+	}
 	else if (type == 6)
 	{
-		GameObject *bing = Find_Building(team,BuildingConstants::TYPE_REFINERY);
+		GameObject *bing = Find_Building_By_Type(team,BuildingConstants::TYPE_REFINERY);
+		if (bing)
+		{
 		Restore_Building(bing);
 		Commands->Set_Health(bing,Commands->Get_Max_Health(obj));
 	}
+	}
 	else if (type == 7)
 	{
-		GameObject *bing = Find_Building(team,BuildingConstants::TYPE_SOLDIER_FACTORY);
+		GameObject *bing = Find_Building_By_Type(team,BuildingConstants::TYPE_SOLDIER_FACTORY);
+		if (bing)
+		{
 		Restore_Building(bing);
 		Commands->Set_Health(bing,Commands->Get_Max_Health(obj));
 	}
+	}
 	else if (type == 8)
 	{
-		GameObject *bing = Find_Building(team,BuildingConstants::TYPE_VEHICLE_FACTORY);
+		GameObject *bing = Find_Building_By_Type(team,BuildingConstants::TYPE_VEHICLE_FACTORY);
+		if (bing)
+		{
 		Restore_Building(bing);
 		Commands->Set_Health(bing,Commands->Get_Max_Health(obj));
 	}
+	}
 	else if (type == 9)
 	{
-		GameObject *bing = Find_Building_By_Name(team,Get_Parameter("BuildingPreset"));
+		GameObject *bing = Find_Building_By_Preset(team,Get_Parameter("BuildingPreset"));
+		if (bing)
+		{
 		Restore_Building(bing);
 		Commands->Set_Health(bing,Commands->Get_Max_Health(obj));
 	}
 }
+}
 
 
 ScriptRegistrant<z_Poke_Restore_Building> z_Poke_Restore_Building_Registrant("z_Poke_Restore_Building","Team=1:int,Type=1:int,BuildingPreset=bla:string");
diff -uwr sourceold/scripts/z_cargo.cpp source/scripts/z_cargo.cpp
--- sourceold/scripts/z_cargo.cpp	2011-10-11 23:14:17.298828100 +0800
+++ source/scripts/z_cargo.cpp	2012-04-15 15:10:53.384156300 +0800
@@ -19,7 +19,7 @@
 
 void z_Pup_Soviet_Shocky::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"Soviet_Shock_Trooper");
 	}
@@ -27,7 +27,7 @@
 
 void z_Pup_Soviet_Officer::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"Soviet_Rifle_Infantry_Officer");
 	}
@@ -35,7 +35,7 @@
 
 void z_Pup_Soviet_Sniper::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"Soviet_Sniper_Coop");
 	}
@@ -43,7 +43,7 @@
 
 void z_Pup_Soviet_Flamer::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"Soviet_Flamethrower_Infantry");
 	}
@@ -51,7 +51,7 @@
 
 void z_Pup_Soviet_Volkov::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"Soviet_Volkov");
 	}
Only in source/scripts: z_center_point.cpp
Only in source/scripts: z_center_point.h
diff -uwr sourceold/scripts/z_coop.cpp source/scripts/z_coop.cpp
--- sourceold/scripts/z_coop.cpp	2011-10-11 23:14:11.353515600 +0800
+++ source/scripts/z_coop.cpp	2012-04-24 12:31:12.207031200 +0800
@@ -15,7 +15,7 @@
 #include "z_coop.h"
 #include "BuildingGameObjDef.h"
 #include "VehicleGameObjDef.h"
-
+#include "ScriptableGameObj.h"
 //Just having a script thats attached to all player type characters
 //in case i think of something that i want to do to players globally...
 
@@ -165,7 +165,7 @@
 {
 	if (!Commands->Is_A_Star(obj))
 	{
-		if (As_SoldierGameObj(obj))
+		if (obj->As_SoldierGameObj())
 		{
 			Attach_Script_Once(obj,"z_AI_Bot_Dropweapons","");
 		}
@@ -178,7 +178,7 @@
 	{
 		if (!Commands->Is_A_Star(obj))
 		{
-			if (As_SoldierGameObj(obj))
+			if (obj->As_SoldierGameObj())
 			{
 				Attach_Script_Once(obj,"z_AI_Bot_Dropweapons","");
 				Commands->Start_Timer(obj,this,45.0f,123454321);
diff -uwr sourceold/scripts/z_endgame.cpp source/scripts/z_endgame.cpp
--- sourceold/scripts/z_endgame.cpp	2011-10-11 23:14:13.342773400 +0800
+++ source/scripts/z_endgame.cpp	2012-04-28 01:57:41.618164000 +0800
@@ -123,7 +123,7 @@
 {
 	if (strcmp(Commands->Get_Preset_Name(enter),"CnC_Allied_Demolition_Truck") == 0)
 	{
-		if (Commands->Get_Health(Find_Building(1,BuildingConstants::TYPE_VEHICLE_FACTORY)) >= 1.0f)//only enable the extra tanks if wf is present and alive
+		if (Find_Building_By_Type(1,BuildingConstants::TYPE_VEHICLE_FACTORY) && Commands->Get_Health(Find_Building_By_Type(1,BuildingConstants::TYPE_VEHICLE_FACTORY)) >= 1.0f)//only enable the extra tanks if wf is present and alive
 		{
 			Commands->Enable_Spawner(100528,1);
 			Commands->Enable_Spawner(100529,1);
